/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of UCL.xs. Do not edit this file, edit UCL.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "UCL.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"
#include "const-c.inc"

#include <ucl.h>

bool implicit_unicode;
int ucl_string_flags;

static ucl_object_t *
_iterate_perl (pTHX_ SV* obj) {
    if ( SvTYPE(obj) == SVt_NULL ) {
        return ucl_object_new();
    }
    else if (
        sv_isobject(obj) && (
               sv_isa(obj, "JSON::PP::Boolean")
            || sv_isa(obj, "Types::Serialiser::BooleanBase")
            || sv_isa(obj, "JSON::XS::Boolean")
            || sv_isa(obj, "Data::MessagePack::Boolean")
            || sv_isa(obj, "boolean")
            || sv_isa(obj, "Mojo::JSON::_Bool")
        )
    ) {
        return ucl_object_frombool( SvTRUE(obj) );
    }
    else if ( SvROK(obj) && SvTYPE(SvRV(obj)) == SVt_PVAV ) {
        ucl_object_t *top, *elm;
        top = ucl_object_typed_new(UCL_ARRAY);
        size_t nums_len = av_len((AV*)SvRV(obj)) + 1;
        for (int i = 0; i < nums_len; i++) {
            SV** num_sv_ptr = av_fetch((AV*)SvRV(obj), i, FALSE);
            SV* num_sv = num_sv_ptr ? *num_sv_ptr : &PL_sv_undef;
            elm = _iterate_perl(aTHX_ num_sv);
            ucl_array_append(top, elm);
        }
        return top;
    }
    else if ( SvROK(obj) && SvTYPE(SvRV(obj)) == SVt_PVHV ) {
        ucl_object_t *top, *elm;
        char *keystr = NULL;
        top = ucl_object_typed_new(UCL_OBJECT);
        HV *hash= (HV*)SvRV(obj);
        HE *iter;
        hv_iterinit(hash);
        int *len;
        for (iter=hv_iternext(hash); iter; iter=hv_iternext(hash)) {
            char* key;
            key = HeKEY(iter);
            elm = _iterate_perl(aTHX_ HeVAL(iter));
            ucl_object_insert_key(top, elm, key, 0, true);
        }
        return top;
    }
    else if ( SvIOK(obj) ) {
        return ucl_object_fromint(SvIV(obj));
    }
    else if ( SvNOK(obj) ) {
        return ucl_object_fromdouble(SvNV(obj));
    }
    else if ( SvPOK(obj) || SvPOKp(obj)) {
        // https://github.com/vstakhov/libucl/blob/master/doc/api.md#ucl_object_fromstring_common
        return ucl_object_fromstring_common( SvPV_nolen(obj), strlen(SvPV_nolen(obj)), ucl_string_flags );
    }
    else if ( !SvOK(obj) ) { // undef
        return ucl_object_new();
    }

    croak("unknown type %d", SvTYPE(obj) );
}

SV *
_ucl_type (pTHX_ ucl_object_t const *obj)
{
    switch (obj->type) {
        case UCL_INT:
            return newSViv((long long)ucl_object_toint (obj));
        case UCL_FLOAT:
            return newSVnv(ucl_object_todouble (obj));
        case UCL_STRING: {
            SV *sv = newSVpv(ucl_object_tostring (obj), 0);
            if (implicit_unicode) {
                SvUTF8_on(sv);
            }
            return sv;
        }
        case UCL_BOOLEAN: {
            SV* rv = newSV_type(SVt_IV);
            sv_setref_iv(rv, "JSON::PP::Boolean", ucl_object_toboolean(obj) ? 1 : 0);
            return rv;
        }
        case UCL_TIME:
            return newSVnv(ucl_object_todouble (obj));
        case UCL_NULL:
            return &PL_sv_undef;
    }
    return NULL;
}

SV *
_iterate_ucl (pTHX_ ucl_object_t const *obj) {
    const ucl_object_t *tmp;
    ucl_object_iter_t it = NULL;

    tmp = obj;

    while ((obj = ucl_object_iterate (tmp, &it, false))) {
        SV *val;

        val = _ucl_type(aTHX_ obj);
        if (!val) {
            SV *key = NULL;

            if (obj->key != NULL) {
                key = newSVpv(ucl_object_key(obj),0);
            }

            if (obj->type == UCL_OBJECT) {
                const ucl_object_t *cur;
                ucl_object_iter_t it_obj = NULL;

                val = sv_2mortal((SV*)newHV());

                while ((cur = ucl_object_iterate (obj, &it_obj, true))) {
                    SV *key = newSVpv(ucl_object_key(cur),0);
                    if (implicit_unicode)
                        SvUTF8_on(key);
                    hv_store_ent((HV*)val, sv_2mortal(key), _iterate_ucl(aTHX_ cur), 0);
                }
                val = newRV(val);
            } else if (obj->type == UCL_ARRAY) {
                const ucl_object_t *cur;
                ucl_object_iter_t it_obj = NULL;

                val = sv_2mortal((SV*)newAV());

                while ((cur = ucl_object_iterate (obj, &it_obj, true))) {
                    av_push((AV*)val, newRV((SV*)_iterate_ucl(aTHX_ cur)));
                }
                val = newRV(val);
            } else if (obj->type == UCL_USERDATA) {
                val = newSVpv(obj->value.ud, 0);
            }
        }
        return val;
    }

    croak("unhandled type");
}

SV *
_load_ucl(pTHX_ struct ucl_parser *parser) {
    SV *ret;
    const char *err = ucl_parser_get_error(parser);

    if (err) {
        croak(err);
    }
    else {
        ucl_object_t *uclobj = ucl_parser_get_object(parser);
        ret = _iterate_ucl(aTHX_ uclobj);
    }

    return ret;
}


#line 181 "UCL.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 325 "UCL.c"

/* INCLUDE:  Including 'const-xs.inc' from 'UCL.xs' */


XS_EUPXS(XS_Config__UCL_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Config__UCL_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sv = ST(0)
;
#line 110 "./const-xs.inc"
#ifndef SYMBIAN
	/* It's not obvious how to calculate this at C pre-processor time.
	   However, any compiler optimiser worth its salt should be able to
	   remove the dead code, and hopefully the now-obviously-unused static
	   function too.  */
	HV *constant_missing = (C_ARRAY_LENGTH(values_for_notfound) > 1)
	    ? get_missing_hash(aTHX) : NULL;
	if ((C_ARRAY_LENGTH(values_for_notfound) > 1)
	    ? hv_exists_ent(constant_missing, sv, 0) : 0) {
	    sv = newSVpvf("Your vendor has not defined Config::UCL macro %" SVf
			  ", used", sv);
	} else
#endif
	{
	    sv = newSVpvf("%" SVf " is not a valid Config::UCL macro",
			  sv);
	}
	PUSHs(sv_2mortal(sv));
#line 360 "UCL.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'UCL.xs' from 'const-xs.inc' */


XS_EUPXS(XS_Config__UCL__ucl_dump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Config__UCL__ucl_dump)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "sv, _implicit_unicode, emitter");
    {
	SV *	RETVAL;
	SV *	sv = ST(0)
;
	bool	_implicit_unicode = (bool)SvTRUE(ST(1))
;
	ucl_emitter_t	emitter = (ucl_emitter_t)SvIV(ST(2))
;
#line 179 "UCL.xs"
        implicit_unicode = _implicit_unicode;
	ucl_object_t *root = NULL;
	root = _iterate_perl(aTHX_ sv);
	if (root) {
            RETVAL = newSVpv((char *)ucl_object_emit(root, emitter), 0);
            if (implicit_unicode)
                SvUTF8_on(RETVAL);
            ucl_object_unref(root);
	}
#line 394 "UCL.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Config__UCL_ucl_validate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Config__UCL_ucl_validate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "schema_sv, data_sv");
    {
	bool	RETVAL;
	SV *	schema_sv = ST(0)
;
	SV *	data_sv = ST(1)
;
#line 194 "UCL.xs"
        ucl_object_t *data, *schema;
        bool r;
        struct ucl_schema_error err;

        SV *schema_error = get_sv("Config::UCL::ucl_schema_error", 0);
        sv_setpv(schema_error, "\0");

        schema = _iterate_perl(aTHX_ schema_sv);
        if (!schema) {
            croak("aaa");
            RETVAL = NULL;
            return;
        }

        data = _iterate_perl(aTHX_ data_sv);
        if (!data) {
            croak("aaa");
            RETVAL = NULL;
            return;
        }

        // validation
        r = ucl_object_validate(schema, data, &err);
        ucl_object_unref(schema);
        ucl_object_unref(data);

        if (!r) {
            //PyErr_SetString (SchemaError, err.msg);
            sv_setpv(schema_error, err.msg);
            RETVAL = false;
        }
        else {
            RETVAL = true;
        }
#line 449 "UCL.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Config__UCL__Parser_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Config__UCL__Parser_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "klass, flags");
    {
	struct ucl_parser *	RETVAL;
	char *	klass = (char *)SvPV_nolen(ST(0))
;
	int	flags = (int)SvIV(ST(1))
;
#line 236 "UCL.xs"
	struct ucl_parser *parser = ucl_parser_new(flags);
        RETVAL = parser;
#line 471 "UCL.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Config::UCL::Parser", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Config__UCL__Parser_ucl_parser_register_variable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Config__UCL__Parser_ucl_parser_register_variable)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "parser, var, value");
    {
	struct ucl_parser *	parser;
	const char *	var = (const char *)SvPV_nolen(ST(1))
;
	const char *	value = (const char *)SvPV_nolen(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Config::UCL::Parser")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    parser = INT2PTR(struct ucl_parser *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Config::UCL::Parser::ucl_parser_register_variable",
			"parser", "struct ucl_parserPtr")
;

	ucl_parser_register_variable(parser, var, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Config__UCL__Parser_ucl_parser_set_filevars); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Config__UCL__Parser_ucl_parser_set_filevars)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "parser, filename, need_expand");
    {
	bool	RETVAL;
	struct ucl_parser *	parser;
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;
	bool	need_expand = (bool)SvTRUE(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Config::UCL::Parser")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    parser = INT2PTR(struct ucl_parser *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Config::UCL::Parser::ucl_parser_set_filevars",
			"parser", "struct ucl_parserPtr")
;

	RETVAL = ucl_parser_set_filevars(parser, filename, need_expand);
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Config__UCL__Parser_ucl_parser_add_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Config__UCL__Parser_ucl_parser_add_string)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "parser, data, len");
    {
	bool	RETVAL;
	struct ucl_parser *	parser;
	const char *	data = (const char *)SvPV_nolen(ST(1))
;
	size_t	len = (size_t)SvUV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Config::UCL::Parser")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    parser = INT2PTR(struct ucl_parser *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Config::UCL::Parser::ucl_parser_add_string",
			"parser", "struct ucl_parserPtr")
;

	RETVAL = ucl_parser_add_string(parser, data, len);
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Config__UCL__Parser_ucl_parser_add_chunk_full); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Config__UCL__Parser_ucl_parser_add_chunk_full)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "parser, data, len, priority, strat, parse_type");
    {
	bool	RETVAL;
	struct ucl_parser *	parser;
	const unsigned char *	data = (const unsigned char *)SvPV_nolen(ST(1))
;
	size_t	len = (size_t)SvUV(ST(2))
;
	unsigned	priority = (unsigned)SvUV(ST(3))
;
	enum ucl_duplicate_strategy	strat = (enum ucl_duplicate_strategy)SvIV(ST(4))
;
	enum ucl_parse_type	parse_type = (enum ucl_parse_type)SvIV(ST(5))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Config::UCL::Parser")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    parser = INT2PTR(struct ucl_parser *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Config::UCL::Parser::ucl_parser_add_chunk_full",
			"parser", "struct ucl_parserPtr")
;

	RETVAL = ucl_parser_add_chunk_full(parser, data, len, priority, strat, parse_type);
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Config__UCL__Parser_ucl_parser_add_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Config__UCL__Parser_ucl_parser_add_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "parser, filename");
    {
	bool	RETVAL;
	struct ucl_parser *	parser;
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Config::UCL::Parser")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    parser = INT2PTR(struct ucl_parser *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Config::UCL::Parser::ucl_parser_add_file",
			"parser", "struct ucl_parserPtr")
;

	RETVAL = ucl_parser_add_file(parser, filename);
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Config__UCL__Parser_ucl_parser_add_file_full); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Config__UCL__Parser_ucl_parser_add_file_full)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "parser, filename, priority, strat, parse_type");
    {
	bool	RETVAL;
	struct ucl_parser *	parser;
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;
	unsigned	priority = (unsigned)SvUV(ST(2))
;
	enum ucl_duplicate_strategy	strat = (enum ucl_duplicate_strategy)SvIV(ST(3))
;
	enum ucl_parse_type	parse_type = (enum ucl_parse_type)SvIV(ST(4))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Config::UCL::Parser")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    parser = INT2PTR(struct ucl_parser *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Config::UCL::Parser::ucl_parser_add_file_full",
			"parser", "struct ucl_parserPtr")
;

	RETVAL = ucl_parser_add_file_full(parser, filename, priority, strat, parse_type);
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Config__UCL__Parser_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Config__UCL__Parser_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "parser");
    {
	struct ucl_parser *	parser;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Config::UCL::Parser")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    parser = INT2PTR(struct ucl_parser *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Config::UCL::Parser::DESTROY",
			"parser", "struct ucl_parserPtr")
;
#line 262 "UCL.xs"
        ucl_parser_free(parser);
#line 695 "UCL.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Config__UCL__Parser_ucl_load); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Config__UCL__Parser_ucl_load)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "parser, _implicit_unicode, _ucl_string_flags");
    {
	SV *	RETVAL;
	struct ucl_parser *	parser;
	bool	_implicit_unicode = (bool)SvTRUE(ST(1))
;
	int	_ucl_string_flags = (int)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Config::UCL::Parser")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    parser = INT2PTR(struct ucl_parser *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Config::UCL::Parser::ucl_load",
			"parser", "struct ucl_parserPtr")
;
#line 267 "UCL.xs"
        implicit_unicode = _implicit_unicode;
        ucl_string_flags = _ucl_string_flags;
        RETVAL = _load_ucl(aTHX_ parser);
#line 728 "UCL.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Config__UCL); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Config__UCL)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Config::UCL::constant", XS_Config__UCL_constant, file, "$");
        (void)newXSproto_portable("Config::UCL::_ucl_dump", XS_Config__UCL__ucl_dump, file, "$$$");
        (void)newXSproto_portable("Config::UCL::ucl_validate", XS_Config__UCL_ucl_validate, file, "$$");
        (void)newXSproto_portable("Config::UCL::Parser::new", XS_Config__UCL__Parser_new, file, "$$");
        (void)newXSproto_portable("Config::UCL::Parser::ucl_parser_register_variable", XS_Config__UCL__Parser_ucl_parser_register_variable, file, "$$$");
        (void)newXSproto_portable("Config::UCL::Parser::ucl_parser_set_filevars", XS_Config__UCL__Parser_ucl_parser_set_filevars, file, "$$$");
        (void)newXSproto_portable("Config::UCL::Parser::ucl_parser_add_string", XS_Config__UCL__Parser_ucl_parser_add_string, file, "$$$");
        (void)newXSproto_portable("Config::UCL::Parser::ucl_parser_add_chunk_full", XS_Config__UCL__Parser_ucl_parser_add_chunk_full, file, "$$$$$$");
        (void)newXSproto_portable("Config::UCL::Parser::ucl_parser_add_file", XS_Config__UCL__Parser_ucl_parser_add_file, file, "$$");
        (void)newXSproto_portable("Config::UCL::Parser::ucl_parser_add_file_full", XS_Config__UCL__Parser_ucl_parser_add_file_full, file, "$$$$$");
        (void)newXSproto_portable("Config::UCL::Parser::DESTROY", XS_Config__UCL__Parser_DESTROY, file, "$");
        (void)newXSproto_portable("Config::UCL::Parser::ucl_load", XS_Config__UCL__Parser_ucl_load, file, "$$$");

    /* Initialisation Section */

#line 2 "./const-xs.inc"
  {
#if defined(dTHX) && !defined(PERL_NO_GET_CONTEXT)
    dTHX;
#endif
    HV *symbol_table = get_hv("Config::UCL::", GV_ADD);

    static const struct iv_s values_for_iv[] =
      {
        { "UCL_EMIT_JSON", 13, UCL_EMIT_JSON },
        { "UCL_EMIT_JSON_COMPACT", 21, UCL_EMIT_JSON_COMPACT },
        { "UCL_EMIT_CONFIG", 15, UCL_EMIT_CONFIG },
        { "UCL_EMIT_YAML", 13, UCL_EMIT_YAML },
        { "UCL_EMIT_MSGPACK", 16, UCL_EMIT_MSGPACK },
        { "UCL_EMIT_MAX", 12, UCL_EMIT_MAX },
        { "UCL_PARSER_ZEROCOPY", 19, UCL_PARSER_ZEROCOPY },
        { "UCL_PARSER_DEFAULT", 18, UCL_PARSER_DEFAULT },
        { "UCL_PARSER_KEY_LOWERCASE", 24, UCL_PARSER_KEY_LOWERCASE },
        { "UCL_PARSER_NO_TIME", 18, UCL_PARSER_NO_TIME },
        { "UCL_PARSER_NO_IMPLICIT_ARRAYS", 29, UCL_PARSER_NO_IMPLICIT_ARRAYS },
        { "UCL_PARSER_SAVE_COMMENTS", 24, UCL_PARSER_SAVE_COMMENTS },
        { "UCL_PARSER_DISABLE_MACRO", 24, UCL_PARSER_DISABLE_MACRO },
        { "UCL_PARSER_NO_FILEVARS", 22, UCL_PARSER_NO_FILEVARS },
        { "UCL_STRING_RAW", 14, UCL_STRING_RAW },
        { "UCL_STRING_ESCAPE", 17, UCL_STRING_ESCAPE },
        { "UCL_STRING_TRIM", 15, UCL_STRING_TRIM },
        { "UCL_STRING_PARSE_BOOLEAN", 24, UCL_STRING_PARSE_BOOLEAN },
        { "UCL_STRING_PARSE_INT", 20, UCL_STRING_PARSE_INT },
        { "UCL_STRING_PARSE_DOUBLE", 23, UCL_STRING_PARSE_DOUBLE },
        { "UCL_STRING_PARSE_TIME", 21, UCL_STRING_PARSE_TIME },
        { "UCL_STRING_PARSE_NUMBER", 23, UCL_STRING_PARSE_NUMBER },
        { "UCL_STRING_PARSE", 16, UCL_STRING_PARSE },
        { "UCL_STRING_PARSE_BYTES", 22, UCL_STRING_PARSE_BYTES },
        { "UCL_DUPLICATE_APPEND", 20, UCL_DUPLICATE_APPEND },
        { "UCL_DUPLICATE_MERGE", 19, UCL_DUPLICATE_MERGE },
        { "UCL_DUPLICATE_REWRITE", 21, UCL_DUPLICATE_REWRITE },
        { "UCL_DUPLICATE_ERROR", 19, UCL_DUPLICATE_ERROR },
        { "UCL_PARSE_UCL", 13, UCL_PARSE_UCL },
        { "UCL_PARSE_MSGPACK", 17, UCL_PARSE_MSGPACK },
        { "UCL_PARSE_CSEXP", 15, UCL_PARSE_CSEXP },
        { "UCL_PARSE_AUTO", 14, UCL_PARSE_AUTO },
        { NULL, 0, 0 } };
	const struct iv_s *value_for_iv = values_for_iv;
        while (value_for_iv->name) {
	    constant_add_symbol(aTHX_  symbol_table, value_for_iv->name,
				value_for_iv->namelen, newSViv(value_for_iv->value));
            ++value_for_iv;
	}
	if (C_ARRAY_LENGTH(values_for_notfound) > 1) {
#ifndef SYMBIAN
	    HV *const constant_missing = get_missing_hash(aTHX);
#endif
	    const struct notfound_s *value_for_notfound = values_for_notfound;
	    do {

		/* Need to add prototypes, else parsing will vary by platform.  */
		HE *he = (HE*) hv_common_key_len(symbol_table,
						 value_for_notfound->name,
						 value_for_notfound->namelen,
						 HV_FETCH_LVALUE, NULL, 0);
		SV *sv;
#ifndef SYMBIAN
		HEK *hek;
#endif
		if (!he) {
		    croak("Couldn't add key '%s' to %%Config::UCL::",
			  value_for_notfound->name);
		}
		sv = HeVAL(he);
		if (!SvOK(sv) && SvTYPE(sv) != SVt_PVGV) {
		    /* Nothing was here before, so mark a prototype of ""  */
		    sv_setpvn(sv, "", 0);
		} else if (SvPOK(sv) && SvCUR(sv) == 0) {
		    /* There is already a prototype of "" - do nothing  */
		} else {
		    /* Someone has been here before us - have to make a real
		       typeglob.  */
		    /* It turns out to be incredibly hard to deal with all the
		       corner cases of sub foo (); and reporting errors correctly,
		       so lets cheat a bit.  Start with a constant subroutine  */
		    CV *cv = newCONSTSUB(symbol_table,
					 value_for_notfound->name,
					 &PL_sv_yes);
		    /* and then turn it into a non constant declaration only.  */
		    SvREFCNT_dec(CvXSUBANY(cv).any_ptr);
		    CvCONST_off(cv);
		    CvXSUB(cv) = NULL;
		    CvXSUBANY(cv).any_ptr = NULL;
		}
#ifndef SYMBIAN
		hek = HeKEY_hek(he);
		if (!hv_common(constant_missing, NULL, HEK_KEY(hek),
 			       HEK_LEN(hek), HEK_FLAGS(hek), HV_FETCH_ISSTORE,
			       &PL_sv_yes, HEK_HASH(hek)))
		    croak("Couldn't add key '%s' to missing_hash",
			  value_for_notfound->name);
#endif
	    } while ((++value_for_notfound)->name);
	}
    /* As we've been creating subroutines, we better invalidate any cached
       methods  */
    mro_method_changed_in(symbol_table);
  }

#line 882 "UCL.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
