BOOT:
  {
#if defined(dTHX) && !defined(PERL_NO_GET_CONTEXT)
    dTHX;
#endif
    HV *symbol_table = get_hv("Config::UCL::", GV_ADD);

    static const struct iv_s values_for_iv[] =
      {
        { "UCL_EMIT_JSON", 13, UCL_EMIT_JSON },
        { "UCL_EMIT_JSON_COMPACT", 21, UCL_EMIT_JSON_COMPACT },
        { "UCL_EMIT_CONFIG", 15, UCL_EMIT_CONFIG },
        { "UCL_EMIT_YAML", 13, UCL_EMIT_YAML },
        { "UCL_EMIT_MSGPACK", 16, UCL_EMIT_MSGPACK },
        { "UCL_EMIT_MAX", 12, UCL_EMIT_MAX },
        { "UCL_PARSER_ZEROCOPY", 19, UCL_PARSER_ZEROCOPY },
        { "UCL_PARSER_DEFAULT", 18, UCL_PARSER_DEFAULT },
        { "UCL_PARSER_KEY_LOWERCASE", 24, UCL_PARSER_KEY_LOWERCASE },
        { "UCL_PARSER_NO_TIME", 18, UCL_PARSER_NO_TIME },
        { "UCL_PARSER_NO_IMPLICIT_ARRAYS", 29, UCL_PARSER_NO_IMPLICIT_ARRAYS },
        { "UCL_PARSER_SAVE_COMMENTS", 24, UCL_PARSER_SAVE_COMMENTS },
        { "UCL_PARSER_DISABLE_MACRO", 24, UCL_PARSER_DISABLE_MACRO },
        { "UCL_PARSER_NO_FILEVARS", 22, UCL_PARSER_NO_FILEVARS },
        { "UCL_STRING_RAW", 14, UCL_STRING_RAW },
        { "UCL_STRING_ESCAPE", 17, UCL_STRING_ESCAPE },
        { "UCL_STRING_TRIM", 15, UCL_STRING_TRIM },
        { "UCL_STRING_PARSE_BOOLEAN", 24, UCL_STRING_PARSE_BOOLEAN },
        { "UCL_STRING_PARSE_INT", 20, UCL_STRING_PARSE_INT },
        { "UCL_STRING_PARSE_DOUBLE", 23, UCL_STRING_PARSE_DOUBLE },
        { "UCL_STRING_PARSE_TIME", 21, UCL_STRING_PARSE_TIME },
        { "UCL_STRING_PARSE_NUMBER", 23, UCL_STRING_PARSE_NUMBER },
        { "UCL_STRING_PARSE", 16, UCL_STRING_PARSE },
        { "UCL_STRING_PARSE_BYTES", 22, UCL_STRING_PARSE_BYTES },
        { "UCL_DUPLICATE_APPEND", 20, UCL_DUPLICATE_APPEND },
        { "UCL_DUPLICATE_MERGE", 19, UCL_DUPLICATE_MERGE },
        { "UCL_DUPLICATE_REWRITE", 21, UCL_DUPLICATE_REWRITE },
        { "UCL_DUPLICATE_ERROR", 19, UCL_DUPLICATE_ERROR },
        { "UCL_PARSE_UCL", 13, UCL_PARSE_UCL },
        { "UCL_PARSE_MSGPACK", 17, UCL_PARSE_MSGPACK },
        { "UCL_PARSE_CSEXP", 15, UCL_PARSE_CSEXP },
        { "UCL_PARSE_AUTO", 14, UCL_PARSE_AUTO },
        { NULL, 0, 0 } };
	const struct iv_s *value_for_iv = values_for_iv;
        while (value_for_iv->name) {
	    constant_add_symbol(aTHX_  symbol_table, value_for_iv->name,
				value_for_iv->namelen, newSViv(value_for_iv->value));
            ++value_for_iv;
	}
	if (C_ARRAY_LENGTH(values_for_notfound) > 1) {
#ifndef SYMBIAN
	    HV *const constant_missing = get_missing_hash(aTHX);
#endif
	    const struct notfound_s *value_for_notfound = values_for_notfound;
	    do {

		/* Need to add prototypes, else parsing will vary by platform.  */
		HE *he = (HE*) hv_common_key_len(symbol_table,
						 value_for_notfound->name,
						 value_for_notfound->namelen,
						 HV_FETCH_LVALUE, NULL, 0);
		SV *sv;
#ifndef SYMBIAN
		HEK *hek;
#endif
		if (!he) {
		    croak("Couldn't add key '%s' to %%Config::UCL::",
			  value_for_notfound->name);
		}
		sv = HeVAL(he);
		if (!SvOK(sv) && SvTYPE(sv) != SVt_PVGV) {
		    /* Nothing was here before, so mark a prototype of ""  */
		    sv_setpvn(sv, "", 0);
		} else if (SvPOK(sv) && SvCUR(sv) == 0) {
		    /* There is already a prototype of "" - do nothing  */
		} else {
		    /* Someone has been here before us - have to make a real
		       typeglob.  */
		    /* It turns out to be incredibly hard to deal with all the
		       corner cases of sub foo (); and reporting errors correctly,
		       so lets cheat a bit.  Start with a constant subroutine  */
		    CV *cv = newCONSTSUB(symbol_table,
					 value_for_notfound->name,
					 &PL_sv_yes);
		    /* and then turn it into a non constant declaration only.  */
		    SvREFCNT_dec(CvXSUBANY(cv).any_ptr);
		    CvCONST_off(cv);
		    CvXSUB(cv) = NULL;
		    CvXSUBANY(cv).any_ptr = NULL;
		}
#ifndef SYMBIAN
		hek = HeKEY_hek(he);
		if (!hv_common(constant_missing, NULL, HEK_KEY(hek),
 			       HEK_LEN(hek), HEK_FLAGS(hek), HV_FETCH_ISSTORE,
			       &PL_sv_yes, HEK_HASH(hek)))
		    croak("Couldn't add key '%s' to missing_hash",
			  value_for_notfound->name);
#endif
	    } while ((++value_for_notfound)->name);
	}
    /* As we've been creating subroutines, we better invalidate any cached
       methods  */
    mro_method_changed_in(symbol_table);
  }

void
constant(sv)
    INPUT:
	SV *		sv;
    PPCODE:
#ifndef SYMBIAN
	/* It's not obvious how to calculate this at C pre-processor time.
	   However, any compiler optimiser worth its salt should be able to
	   remove the dead code, and hopefully the now-obviously-unused static
	   function too.  */
	HV *constant_missing = (C_ARRAY_LENGTH(values_for_notfound) > 1)
	    ? get_missing_hash(aTHX) : NULL;
	if ((C_ARRAY_LENGTH(values_for_notfound) > 1)
	    ? hv_exists_ent(constant_missing, sv, 0) : 0) {
	    sv = newSVpvf("Your vendor has not defined Config::UCL macro %" SVf
			  ", used", sv);
	} else
#endif
	{
	    sv = newSVpvf("%" SVf " is not a valid Config::UCL macro",
			  sv);
	}
	PUSHs(sv_2mortal(sv));
